unit EVRSub;

{$Z4}

interface

uses Windows, ActiveX;

const
  IID_IMFVideoDisplayControl: TGUID = '{A490B1E4-AB84-4D31-A1B2-181E03B1077A}';
  CLSID_EnhancedVideoRenderer: TGUID = '{FA10746C-9B63-4B6C-BC49-FC300EA5F256}';
  MR_VIDEO_RENDER_SERVICE: TGUID = '{1092A86C-AB1A-459A-A336-831FBC4D11FF}';

type
  PMFVideoNormalizedRect = ^TMFVideoNormalizedRect;
  TMFVideoNormalizedRect = record
    left: Single;
    top: Single;
    right: Single;
    bottom: Single;
  end;

  IMFGetService = interface(IUnknown)
      ['{FA993888-4383-415A-A930-DD472A8CF6F7}']
      function GetService(const GuidService: TGUID; const IID: TIID; out Object_): HRESULT; stdcall;
  end;

  TMFVideoAspectRatioMode = (
    MFVideoARMode_None = 0,
    MFVideoARMode_PreservePicture = 1,
    MFVideoARMode_PreservePixel = 2,
    MFVideoARMode_NonLinearStretch = 4,
    MFVideoARMode_Mask = 7
  );

  IMFVideoDisplayControl = interface(IUnknown)
    ['{A490B1E4-AB84-4D31-A1B2-181E03B1077A}']
    function GetNativeVideoSize(Video: PSize; ARVideo: PSize): HRESULT; stdcall;
    function GetIdealVideoSize(Min: PSize; Max: PSize): HRESULT; stdcall;
    function SetVideoPosition(const Source: PMFVideoNormalizedRect; const Dest: PRect): HRESULT; stdcall;
    function GetVideoPosition(out Source: TMFVideoNormalizedRect; out Dest: TRECT): HRESULT; stdcall;
    function SetAspectRatioMode(AspectRatioMode: TMFVideoAspectRatioMode): HRESULT; stdcall;
    function GetAspectRatioMode(out AspectRatioMode: TMFVideoAspectRatioMode): HRESULT; stdcall;
    function SetVideoWindow(hwndVideo: HWND): HRESULT; stdcall;
    function GetVideoWindow(out hwndVideo: HWND): HRESULT; stdcall;
    function RepaintVideo: HRESULT; stdcall;
    function GetCurrentImage(Bih: PBITMAPINFOHEADER; out Dib; out cbDib: DWORD; TimeStamp: PInt64): HRESULT; stdcall;
    function SetBorderColor(Clr: COLORREF): HRESULT; stdcall;
    function GetBorderColor(out Clr: COLORREF): HRESULT; stdcall;
    function SetRenderingPrefs(RenderFlags: DWORD): HRESULT; stdcall;
    function GetRenderingPrefs(out RenderFlags: DWORD): HRESULT; stdcall;
    function SetFullscreen(Fullscreen: Boolean): HRESULT; stdcall;
    function GetFullscreen(out Fullscreen: Boolean): HRESULT; stdcall;
  end;

implementation
end.
